/*
 * Copyright (c) 2024 Qualcomm Innovation Center, Inc. All rights reserved.
 * SPDX-License-Identifier: BSD-3-Clause-Clear
*/

/*
 * device_inst_from_xml.h
 *
 *  Created on: 28-May-2020
 *      Author: HIMADRI
 */

#ifndef APPS_WIFIMANAGER_INC_DEVICE_INST_FROM_XML_H_
#define APPS_WIFIMANAGER_INC_DEVICE_INST_FROM_XML_H_

#include "DALStdDef.h"
#include "DALSysTypes.h"
#include "nt_wlan.h"

typedef struct DALDeviceObject_1
{
	uint32 SYS_TUNE_WLAN_NUM_IRAM_BANKS;
	uint32 SYS_TUNE_WLAN_MULTI_MBOX_ENABLE;
	uint32 SYS_TUNE_WLAN_ENABLE_FASTCHANNEL_SWITCH;
	uint32 SYS_TUNE_WLAN_NUM_RXBUF;
	uint32 SYS_TUNE_WLAN_NUM_TXBUF;
	uint32 SYS_TUNE_WLAN_NUM_MGMTBUF;
	uint32 SYS_TUNE_WLAN_NUM_SOFTAP_CLIENTS;
	uint32 SYS_TUNE_WLAN_OOB_GPIO_INT_PIN;
	uint32 SYS_TUNE_WLAN_GPIO_COEX_BTACTIVE;
	uint32 SYS_TUNE_WLAN_GPIO_COEX_BTPRI_1;
	uint32 SYS_TUNE_WLAN_GPIO_COEX_BTPRI_2;
	uint32 SYS_TUNE_WLAN_GPIO_COEX_WLAN_ACTIVE;
	uint32 SYS_TUNE_WLAN_DSET_PENDING_MAX;
	uint32 SYS_TUNE_WLAN_PERSISTENT_MAX_LIST_COUNT;
	uint32 SYS_TUNE_WLAN_FLOW_CONTROL_ENABLE;
	uint32 SYS_TUNE_WLAN_ERROR_DUMP_ENABLE;
	uint32 SYS_TUNE_NET_BRIDGE_DATABASE_SIZE;
	uint32 SYS_TUNE_NET_MAX_SOCKETS;
	uint32 SYS_TUNE_WLAN_CLOCK_SETTLING_TIME;
	uint32 SYS_TUNE_WLAN_NULL_PACKET_ENABLE;
	uint32 SYS_TUNE_NET_MAX_DHCP_SERVER_ENTRIES;
	uint32 SYS_TUNE_WLAN_OTP_MAC_DEVID;
	uint32 AP_NETWORK_DEV;
	uint32 INFRA_NETWORK_DEV;
	uint32 SYS_TUNE_WLAN_FW_RESERVE6;
	uint32 SYS_TUNE_WLAN_FW_RESERVE7;
	uint32 SYS_TUNE_WLAN_FW_RESERVE8;
	uint32 SYS_TUNE_WLAN_FW_RESERVE9;
	uint32 SYS_TUNE_WLAN_FW_RESERVE10;
	uint32 SYS_TUNE_WLAN_FW_RESERVE11;
	uint32 SYS_TUNE_WLAN_FW_RESERVE12;
	uint32 SYS_TUNE_WLAN_FW_RESERVE13;
	uint32 SYS_TUNE_WLAN_FW_RESERVE14;
	uint32 SYS_TUNE_WLAN_FW_RESERVE15;
	uint32 SYS_TUNE_WLAN_FW_RESERVE16;
	uint32 SYS_TUNE_WLAN_FW_RESERVE17;
	uint32 SYS_TUNE_WLAN_FW_RESERVE18;
	uint32 SYS_TUNE_WLAN_FW_RESERVE19;
	uint32 SYS_TUNE_WLAN_FW_RESERVE20;

}DALDeviceObject_1;

typedef struct DALDeviceObject_2
{
	uint32 SYS_TUNE_WLAN_DRV_NUM_OF_DEVICES;
	uint32 SYS_TUNE_WLAN_DRV_TASK_PRIORITY;
	uint32 SYS_TUNE_WLAN_DRV_TASK_STACK_SIZE;
	uint32 SYS_TUNE_WLAN_TEMP_LPO_TRIGGER_THRESHOLD;
	uint32 SYS_TUNE_WLAN_TKIP_COUNTERMEASURES_ENABLE;
	uint32 SYS_TUNE_WLAN_ENABLE_FW_ERR_COLLECT;
	uint32 SYS_TUNE_WLAN_BUS_SELECT;
	uint32 SYS_TUNE_WLAN_ENABLE_STORERECALL;
	uint32 SYS_TUNE_WLAN_FW_FILE_FORMAT;
	uint32 SYS_TUNE_WLAN_GPIO_PWD;
	uint32 SYS_TUNE_WLAN_GPIO_OOB;
	uint32 SYS_TUNE_WLAN_GPIO_SPI_INTR;
	uint32 SYS_TUNE_WLAN_GPIO_PWD_CONFIG;
	uint32 SYS_TUNE_WLAN_GPIO_OOB_CONFIG;
	uint32 SYS_TUNE_WLAN_GPIO_SPI_INTR_CONFIG;
	uint32 SYS_TUNE_WLAN_ENABLE_STACK_OFFLOAD;
	uint32 SYS_TUNE_WLAN_BUS_CLOCK_FREQ;
	uint32 SYS_TUNE_WLAN_SDIO_BUS_WIDTH;
	uint32 SYS_TUNE_WLAN_GPIO_CLK_REQ;
	uint32 SYS_TUNE_WLAN_GPIO_CLK_REQ_CONFIG;
	uint32 SYS_TUNE_WLAN_NETBUF_TXRX_POOL_SIZE;
	uint32 SYS_TUNE_WLAN_NETBUF_RX_THRESHOLD;
	uint32 SYS_TUNE_WLAN_HOST_PLATFORM_FPGA;
	uint32 SYS_TUNE_WLAN_DRIVER_SUSP_RESUME_ENABLE;
	uint32 SYS_TUNE_WLAN_DRIVER_SLEEP_ENABLE;
	uint32 SYS_TUNE_WLAN_ENABLE_KF_UART_LOGS;
	uint32 SYS_TUNE_WLAN_HOST_RESERVE3;
	uint32 SYS_TUNE_WLAN_HOST_RESERVE4;
	uint32 SYS_TUNE_WLAN_HOST_RESERVE5;
	uint32 SYS_TUNE_WLAN_HOST_RESERVE6;
	uint32 SYS_TUNE_WLAN_HOST_RESERVE7;
}DALDeviceObject_2;

typedef struct DALDeviceObject_3
{
	uint32 SYS_TUNE_WLAN_RESERVE0;
	uint32 SYS_TUNE_WLAN_RESERVE1;
	uint32 SYS_TUNE_WLAN_RESERVE2;
	uint32 SYS_TUNE_WLAN_RESERVE3;
	uint32 SYS_TUNE_WLAN_RESERVE4;
	uint32 SYS_TUNE_WLAN_RESERVE5;
	uint32 SYS_TUNE_WLAN_RESERVE6;
	uint32 SYS_TUNE_WLAN_RESERVE7;
	uint32 SYS_TUNE_WLAN_RESERVE8;
	uint32 SYS_TUNE_WLAN_RESERVE9;

}DALDeviceObject_3;


typedef struct dal_config_facade_t
{
	DALDeviceObject_1 DALDeviceBin_1;
	DALDeviceObject_2 DALDeviceBin_2;
	DALDeviceObject_3 DALDeviceBin_3;
	resp_function_dev dev_callb0;
	resp_function_dev dev_callb1;
	resp_function_dev dev_callb2;
	uint32    	  	  sdk_inconfig;
	uint32    	      sfr_inconfig;
	uint32    	  	  annnum_inconfig;
	void* 			  dev_confg_inst;
}dal_config_facade_t;


extern  dal_config_facade_t Dal_struct_inst;

#endif /* APPS_WIFIMANAGER_INC_DEVICE_INST_FROM_XML_H_ */
